/*
 * Copyright Fraunhofer ISE, energy & meteo Systems GmbH, and other contributors 2011
 *
 * This file is part of openIEC61850.
 * For more information visit http://www.openmuc.org 
 *
 * openIEC61850 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * openIEC61850 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with openIEC61850.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.openiec61850.common.model.datypes.commonacsi;

import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

/**
 * 
 * Check packed list according to 61850-7-2
 * 
 * @author sfeuerhahn
 * 
 */
public class Check extends BasicDataAttribute {

	public Check(ObjectReference objectReference, FunctionalConstraint fc, String sAddr, boolean dchg, boolean dupd) {
		this.objectReference = objectReference;
		this.fc = fc;
		this.basicType = DAType.CHECK;
		this.sAddr = sAddr;
		this.dchg = dchg;
		this.dupd = dupd;
	}

	public boolean synchrocheck = false;
	public boolean interlock_check = false;

	@Override
	public void setDefault() {
		synchrocheck = false;
		interlock_check = false;
	}

	@Override
	public Check copy() {
		return new Check(this.objectReference, this.fc, this.sAddr, this.dchg, this.dupd);
	}

	@Override
	public Object getValue() {
		return new Boolean(dchg);
	}
}
